3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
49 # Resolve a path to be relative to another path. This is intended for
50 # converting submodule paths when git-submodule is run in a subdirectory
51 # and only handles paths where the directory separator is '/'.
53 # The output is the first argument as a path relative to the second argument,
54 # which defaults to $wt_prefix if it is omitted.
57 local target curdir result
59 curdir=${2-$wt_prefix}
63 while test -n "$curdir"
67 target=${target#"$curdir"/}
73 if test "$curdir" = "${curdir%/*}"
86 if test "$1" = "#unmatched"
93 # Print a submodule configuration setting
99 # Checks in the usual git-config places first (for overrides),
100 # otherwise it falls back on .gitmodules. This allows you to
101 # distribute project-wide defaults in .gitmodules, while still
102 # customizing individual repositories if necessary. If the option is
103 # not in .gitmodules either, print a default value.
105 get_submodule_config () {
109 value=$(git config submodule."$name"."$option")
112 value=$(git config -f .gitmodules submodule."$name"."$option")
114 printf '%s' "${value:-$default}"
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
122 # Sanitize the local git environment for use within a submodule. We
123 # can't simply use clear_local_git_env since we want to preserve some
124 # of the settings from GIT_CONFIG_PARAMETERS.
125 sanitize_submodule_env()
127 sanitized_config=$(git submodule--helper sanitize-config)
129 GIT_CONFIG_PARAMETERS=$sanitized_config
133 # Add a new submodule to the working tree, .gitmodules and the index
137 # optional branch is stored in global branch variable
141 # parse $args after "submodule ... add".
147 case "$2" in '') usage ;; esac
158 case "$2" in '') usage ;; esac
163 reference_path="${1#--reference=}"
166 case "$2" in '') usage ;; esac
171 case "$2" in '') usage ;; esac
192 if test -n "$reference_path"
194 is_absolute_path "$reference_path" ||
195 reference_path="$wt_prefix$reference_path"
197 reference="--reference=$reference_path"
203 if test -z "$sm_path"; then
204 sm_path=$(printf '%s\n' "$repo" |
205 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
208 if test -z "$repo" || test -z "$sm_path"; then
212 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
214 # assure repo is absolute or relative to parent
217 test -z "$wt_prefix" ||
218 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
220 # dereference source url relative to parent's url
221 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
228 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
233 # multiple //; leading ./; /./; /../; trailing /
234 sm_path=$(printf '%s/\n' "$sm_path" |
244 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
245 die "$(eval_gettext "'\$sm_path' already exists in the index")"
247 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
249 eval_gettextln "The following path is ignored by one of your .gitignore files:
251 Use -f if you really want to add it." >&2
255 if test -n "$custom_name"
257 sm_name="$custom_name"
262 # perhaps the path exists and is already a git repo, else clone it
263 if test -e "$sm_path"
265 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
267 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
269 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
273 if test -d ".git/modules/$sm_name"
277 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
278 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
279 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
280 echo >&2 " $realrepo"
281 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
282 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
284 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
287 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
289 sanitize_submodule_env
291 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 '') git checkout -f -q ;;
294 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
298 git config submodule."$sm_name".url "$realrepo"
300 git add $force "$sm_path" ||
301 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
303 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
304 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
307 git config -f .gitmodules submodule."$sm_name".branch "$branch"
309 git add --force .gitmodules ||
310 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
314 # Execute an arbitrary command sequence in each checked out
317 # $@ = command to execute
321 # parse $args after "submodule ... foreach".
343 # dup stdin so that it can be restored when running the external
344 # command in the subshell (and a recursive call to this function)
347 git submodule--helper list --prefix "$wt_prefix"|
348 while read mode sha1 stage sm_path
350 die_if_unmatched "$mode"
351 if test -e "$sm_path"/.git
353 displaypath=$(relative_path "$prefix$sm_path")
354 say "$(eval_gettext "Entering '\$displaypath'")"
355 name=$(git submodule--helper name "$sm_path")
357 prefix="$prefix$sm_path/"
358 sanitize_submodule_env
360 sm_path=$(relative_path "$sm_path") &&
361 # we make $path available to scripts ...
369 if test -n "$recursive"
371 cmd_foreach "--recursive" "$@"
374 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
380 # Register submodules in .git/config
382 # $@ = requested paths (default to all)
386 # parse $args after "submodule ... init".
407 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
411 # Unregister submodules from .git/config and remove their work tree
413 # $@ = requested paths (use '.' to deinit all submodules)
417 # parse $args after "submodule ... deinit".
445 if test -n "$deinit_all" && test "$#" -ne 0
447 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
450 if test $# = 0 && test -z "$deinit_all"
452 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
455 git submodule--helper list --prefix "$wt_prefix" "$@" |
456 while read mode sha1 stage sm_path
458 die_if_unmatched "$mode"
459 name=$(git submodule--helper name "$sm_path") || exit
461 displaypath=$(relative_path "$sm_path")
463 # Remove the submodule work tree (unless the user already did it)
464 if test -d "$sm_path"
466 # Protect submodules containing a .git directory
467 if test -d "$sm_path/.git"
469 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
470 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
475 git rm -qn "$sm_path" ||
476 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
479 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
480 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
483 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
485 # Remove the .git/config entries (unless the user already did it)
486 if test -n "$(git config --get-regexp submodule."$name\.")"
488 # Remove the whole section so we have a clean state when
489 # the user later decides to init this submodule again
490 url=$(git config submodule."$name".url)
491 git config --remove-section submodule."$name" 2>/dev/null &&
492 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
497 is_tip_reachable () (
498 sanitize_submodule_env &&
500 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
504 fetch_in_submodule () (
505 sanitize_submodule_env &&
511 git fetch $(get_default_remote) "$2" ;;
516 # Update each submodule path to correct revision, using clone and checkout as needed
518 # $@ = requested paths (default to all)
522 # parse $args after "submodule ... update".
545 case "$2" in '') usage ;; esac
546 reference="--reference=$2"
562 case "$2" in '') usage ;; esac
570 case "$2" in '') usage ;; esac
593 cmd_init "--" "$@" || return
597 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
598 ${wt_prefix:+--prefix "$wt_prefix"} \
599 ${prefix:+--recursive-prefix "$prefix"} \
600 ${update:+--update "$update"} \
601 ${reference:+--reference "$reference"} \
602 ${depth:+--depth "$depth"} \
604 "$@" || echo "#unmatched"
607 while read mode sha1 stage just_cloned sm_path
609 die_if_unmatched "$mode"
611 name=$(git submodule--helper name "$sm_path") || exit
612 url=$(git config submodule."$name".url)
613 branch=$(get_submodule_config "$name" branch master)
614 if ! test -z "$update"
616 update_module=$update
618 update_module=$(git config submodule."$name".update)
619 if test -z "$update_module"
621 update_module="checkout"
625 displaypath=$(relative_path "$prefix$sm_path")
627 if test $just_cloned -eq 1
630 update_module=checkout
632 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
633 git rev-parse --verify HEAD) ||
634 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
639 if test -z "$nofetch"
641 # Fetch remote before determining tracking $sha1
642 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
643 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
645 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
646 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
647 git rev-parse --verify "${remote_name}/${branch}") ||
648 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
651 if test "$subsha1" != "$sha1" || test -n "$force"
654 # If we don't already have a -f flag and the submodule has never been checked out
655 if test -z "$subsha1" && test -z "$force"
660 if test -z "$nofetch"
662 # Run fetch only if $sha1 isn't present or it
663 # is not reachable from a ref.
664 is_tip_reachable "$sm_path" "$sha1" ||
665 fetch_in_submodule "$sm_path" ||
666 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
668 # Now we tried the usual fetch, but $sha1 may
669 # not be reachable from any of the refs
670 is_tip_reachable "$sm_path" "$sha1" ||
671 fetch_in_submodule "$sm_path" "$sha1" ||
672 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
676 case "$update_module" in
678 command="git checkout $subforce -q"
679 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
680 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
684 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
685 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
686 must_die_on_failure=yes
690 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
691 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
692 must_die_on_failure=yes
695 command="${update_module#!}"
696 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
697 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
698 must_die_on_failure=yes
701 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
704 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
707 elif test -n "$must_die_on_failure"
709 die_with_status 2 "$die_msg"
711 err="${err};$die_msg"
716 if test -n "$recursive"
719 prefix=$(relative_path "$prefix$sm_path/")
721 sanitize_submodule_env
728 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
731 err="${err};$die_msg"
734 die_with_status $res "$die_msg"
759 sanitize_submodule_env
761 git describe "$2" 2>/dev/null ||
762 git describe --tags "$2" 2>/dev/null ||
763 git describe --contains "$2" 2>/dev/null ||
764 git describe --all --always "$2"
767 test -z "$revname" || revname=" ($revname)"
770 # Show commit summary for submodules in index or working tree
772 # If '--cached' is given, show summary between index and given commit,
773 # or between working tree and given commit
775 # $@ = [commit (default 'HEAD'),] requested paths (default all)
782 # parse $args after "submodule ... summary".
797 isnumber "$summary_limit" || usage
801 summary_limit="${1#--summary-limit=}"
802 isnumber "$summary_limit" || usage
818 test $summary_limit = 0 && return
820 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
824 elif test -z "$1" || test "$1" = "HEAD"
826 # before the first commit: compare with an empty tree
827 head=$(git hash-object -w -t tree --stdin </dev/null)
828 test -z "$1" || shift
836 die "$(gettext "The --cached option cannot be used with the --files option")"
842 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
843 # Get modified modules cared by user
844 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
845 sane_egrep '^:([0-7]* )?160000' |
846 while read mod_src mod_dst sha1_src sha1_dst status sm_path
848 # Always show modules deleted or type-changed (blob<->module)
849 if test "$status" = D || test "$status" = T
851 printf '%s\n' "$sm_path"
854 # Respect the ignore setting for --for-status.
855 if test -n "$for_status"
857 name=$(git submodule--helper name "$sm_path")
858 ignore_config=$(get_submodule_config "$name" ignore none)
859 test $status != A && test $ignore_config = all && continue
861 # Also show added or modified modules which are checked out
862 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
863 printf '%s\n' "$sm_path"
867 test -z "$modules" && return
869 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
870 sane_egrep '^:([0-7]* )?160000' |
872 while read mod_src mod_dst sha1_src sha1_dst status name
874 if test -z "$cached" &&
875 test $sha1_dst = 0000000000000000000000000000000000000000
879 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
881 100644 | 100755 | 120000)
882 sha1_dst=$(git hash-object $name)
888 eval_gettextln "unexpected mode \$mod_dst" >&2
895 test $mod_src = 160000 &&
896 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
899 test $mod_dst = 160000 &&
900 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
903 display_name=$(relative_path "$name")
906 case "$missing_src,$missing_dst" in
908 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
911 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
914 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
919 if test $mod_src = 160000 && test $mod_dst = 160000
921 range="$sha1_src...$sha1_dst"
922 elif test $mod_src = 160000
928 GIT_DIR="$name/.git" \
929 git rev-list --first-parent $range -- | wc -l
931 total_commits=" ($(($total_commits + 0)))"
935 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
936 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
939 blob="$(gettext "blob")"
940 submodule="$(gettext "submodule")"
941 if test $mod_dst = 160000
943 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
945 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
948 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
952 # Don't give error msg for modification whose dst is not submodule
953 # i.e. deleted or changed to blob
954 test $mod_dst = 160000 && echo "$errmsg"
956 if test $mod_src = 160000 && test $mod_dst = 160000
959 test $summary_limit -gt 0 && limit="-$summary_limit"
960 GIT_DIR="$name/.git" \
961 git log $limit --pretty='format: %m %s' \
962 --first-parent $sha1_src...$sha1_dst
963 elif test $mod_dst = 160000
965 GIT_DIR="$name/.git" \
966 git log --pretty='format: > %s' -1 $sha1_dst
968 GIT_DIR="$name/.git" \
969 git log --pretty='format: < %s' -1 $sha1_src
977 # List all submodules, prefixed with:
978 # - submodule not initialized
979 # + different revision checked out
981 # If --cached was specified the revision in the index will be printed
982 # instead of the currently checked out revision.
984 # $@ = requested paths (default to all)
988 # parse $args after "submodule ... status".
1015 git submodule--helper list --prefix "$wt_prefix" "$@" |
1016 while read mode sha1 stage sm_path
1018 die_if_unmatched "$mode"
1019 name=$(git submodule--helper name "$sm_path") || exit
1020 url=$(git config submodule."$name".url)
1021 displaypath=$(relative_path "$prefix$sm_path")
1022 if test "$stage" = U
1024 say "U$sha1 $displaypath"
1027 if test -z "$url" ||
1029 ! test -d "$sm_path"/.git &&
1030 ! test -f "$sm_path"/.git
1033 say "-$sha1 $displaypath"
1036 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1038 set_name_rev "$sm_path" "$sha1"
1039 say " $sha1 $displaypath$revname"
1041 if test -z "$cached"
1043 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1045 set_name_rev "$sm_path" "$sha1"
1046 say "+$sha1 $displaypath$revname"
1049 if test -n "$recursive"
1052 prefix="$displaypath/"
1053 sanitize_submodule_env
1058 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1063 # Sync remote urls for submodules
1064 # This makes the value for remote.$remote.url match the value
1065 # specified in .gitmodules.
1093 git submodule--helper list --prefix "$wt_prefix" "$@" |
1094 while read mode sha1 stage sm_path
1096 die_if_unmatched "$mode"
1097 name=$(git submodule--helper name "$sm_path")
1098 url=$(git config -f .gitmodules --get submodule."$name".url)
1100 # Possibly a url relative to parent
1103 # rewrite foo/bar as ../.. to find path from
1104 # submodule work tree to superproject work tree
1105 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1106 # guarantee a trailing /
1107 up_path=${up_path%/}/ &&
1108 # path from submodule work tree to submodule origin repo
1109 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1110 # path from superproject work tree to submodule origin repo
1111 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1114 sub_origin_url="$url"
1115 super_config_url="$url"
1119 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1121 displaypath=$(relative_path "$prefix$sm_path")
1122 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1123 git config submodule."$name".url "$super_config_url"
1125 if test -e "$sm_path"/.git
1128 sanitize_submodule_env
1130 remote=$(get_default_remote)
1131 git config remote."$remote".url "$sub_origin_url"
1133 if test -n "$recursive"
1135 prefix="$prefix$sm_path/"
1144 # This loop parses the command line arguments to find the
1145 # subcommand name to dispatch. Parsing of the subcommand specific
1146 # options are primarily done by the subcommand implementations.
1147 # Subcommand specific options such as --branch and --cached are
1148 # parsed here as well, for backward compatibility.
1150 while test $# != 0 && test -z "$command"
1153 add | foreach | init | deinit | update | status | summary | sync)
1183 # No command word defaults to "status"
1184 if test -z "$command"
1194 # "-b branch" is accepted only by "add"
1195 if test -n "$branch" && test "$command" != add
1200 # "--cached" is accepted only by "status" and "summary"
1201 if test -n "$cached" && test "$command" != status && test "$command" != summary